public class Trie{
	public TrieNode root = new TrieNode(0);
	
	public String getWord(String text){
		TrieNode node = root;
		text = text.toLowerCase();
		for(int i = 0; i < text.length(); i++){
			int index = TrieNode.charToIndex(text.charAt(i));
			TrieNode child = node.getChild(index);
			if(child == null){
				return null;
			} 
			else{
				node = child;
				if(node.isLeaf()) break;
			}
		}
		if(node.getContent() != null) return node.getContent();
		if(node.getPrefix() != null) return node.getPrefix();
		return null;
	}
	
	public boolean contains(String word){
		TrieNode node = root;
		word = word.toLowerCase();
		for(int i = 0; i < word.length(); i++){
			int index = TrieNode.charToIndex(word.charAt(i));
			TrieNode child = node.getChild(index);
			if(child == null) {
				return false;
			} 
			else{
				if(child.isLeaf()){
					return child.getContent().equals(word);
				} 
				else{
					node = child;
				}
			}
		}
		if(node.getPrefix() != null && node.getPrefix().equals(word)){
			return true;
		}
		return false;
	}
	
	public void addWord(String word){
		word = word.toLowerCase();
		root.addWord(word);
	}
}